#include <iostream>
#include "mpi.h"
#include "omp.h"
using namespace std;
int main(int argc,char **argv)
{
  int rank,size;
  MPI_Init(&argc,&argv);
  MPI_Comm_rank(MPI_COMM_WORLD,&rank);
  MPI_Comm_size(MPI_COMM_WORLD,&size);
  int namesize;
  char name[512];
  MPI_Get_processor_name(name,&namesize);
  #pragma omp parallel 
  {
    cout << "hello from task " << rank << " thread " << omp_get_thread_num() << " out of " << size << "x" << omp_get_num_threads() << " tasks x threads running on " <<  name << " " <<  endl;
  }
  MPI_Finalize();
  return 0;
}
